diff -urN ../sys/dev/en/midwayvar.h ./dev/en/midwayvar.h
--- ../sys/dev/en/midwayvar.h	Wed Jul 29 14:34:13 1998
+++ ./dev/en/midwayvar.h	Tue Oct  2 22:06:19 2001
@@ -80,14 +80,17 @@
 
 #define DV_IFNET 1
 
-struct cfdriver {
-  int zero;
-  char *name;
-  int one;
-  int cd_ndevs;
-  void *cd_devs[NEN];
-};
+#endif
 
+#if 1 /* for ATM_PVCEXT */
+#include <sys/queue.h>
+
+/* round-robin scheduler */
+struct rrp {
+	struct rrp *next;
+	struct ifnet *ifp;
+	int	nref;
+};
 #endif
 
 /*
@@ -143,6 +146,10 @@
   u_int8_t txspeed[MID_N_VC];	/* speed of tx on a VC */
   u_int8_t txvc2slot[MID_N_VC]; /* map VC to slot */
 
+#if 1 /* for ATM_PVCEXT */
+  struct rrp *txrrp;		/* round-robin pointer to ifnet */
+#endif
+
   /* recv vc ctrl. (per vc).   maps VC number to recv slot */
   u_int16_t rxvc2slot[MID_N_VC];
   int en_nrx;			/* # of active rx slots */
@@ -195,6 +202,10 @@
   u_int8_t bestburstmask;	/* bits to check if not multiple of burst */
   u_int8_t alburst;		/* align dma bursts? */
   u_int8_t is_adaptec;		/* adaptec version of midway? */
+
+#if 1 /* for ATM_PVCEXT */
+  LIST_HEAD(sif_list, pvcsif) sif_list;	/* pvc subinterface list */
+#endif
 };
 
 /*
diff -urN ../sys/dev/ep/if_ep.c ./dev/ep/if_ep.c
--- ../sys/dev/ep/if_ep.c	Tue Jul 18 06:24:26 2000
+++ ./dev/ep/if_ep.c	Tue Oct  2 22:06:19 2001
@@ -297,7 +297,8 @@
 	ifp->if_ioctl = ep_if_ioctl;
 	ifp->if_watchdog = ep_if_watchdog;
 	ifp->if_init = ep_if_init;
-	ifp->if_snd.ifq_maxlen = IFQ_MAXLEN;
+	IFQ_SET_MAXLEN(&ifp->if_snd, IFQ_MAXLEN);
+	IFQ_SET_READY(&ifp->if_snd);
 
 	if (!sc->epb.mii_trans) {
 		ifmedia_init(&sc->ifmedia, 0, ep_ifmedia_upd, ep_ifmedia_sts);
@@ -452,7 +453,7 @@
 
 startagain:
     /* Sneak a peek at the next packet */
-    m = ifp->if_snd.ifq_head;
+    IFQ_POLL(&ifp->if_snd, m);
     if (m == 0) {
 	return;
     }
@@ -469,7 +470,7 @@
     if (len + pad > ETHER_MAX_LEN) {
 	/* packet is obviously too large: toss it */
 	++ifp->if_oerrors;
-	IF_DEQUEUE(&ifp->if_snd, m);
+	IFQ_DEQUEUE(&ifp->if_snd, m);
 	m_freem(m);
 	goto readcheck;
     }
@@ -485,7 +486,7 @@
 	outw(BASE + EP_COMMAND, SET_TX_AVAIL_THRESH | EP_THRESH_DISABLE);
     }
 
-    IF_DEQUEUE(&ifp->if_snd, m);
+    IFQ_DEQUEUE(&ifp->if_snd, m);
 
     s = splhigh();
 
@@ -533,7 +534,7 @@
 	 * we check if we have packets left, in that case we prepare to come
 	 * back later
 	 */
-	if (ifp->if_snd.ifq_head) {
+	if (!IFQ_IS_EMPTY(&ifp->if_snd)) {
 	    outw(BASE + EP_COMMAND, SET_TX_AVAIL_THRESH | 8);
 	}
 	return;
@@ -631,7 +632,7 @@
 		     * To have a tx_avail_int but giving the chance to the
 		     * Reception
 		     */
-		    if (ifp->if_snd.ifq_head) {
+		    if (!IFQ_IS_EMPTY(&ifp->if_snd)) {
 			outw(BASE + EP_COMMAND, SET_TX_AVAIL_THRESH | 8);
 		    }
 		}
diff -urN ../sys/dev/ex/if_ex.c ./dev/ex/if_ex.c
--- ../sys/dev/ex/if_ex.c	Mon Mar  5 14:33:20 2001
+++ ./dev/ex/if_ex.c	Tue Oct  2 22:06:19 2001
@@ -241,7 +241,8 @@
 	ifp->if_ioctl = ex_ioctl;
 	ifp->if_watchdog = ex_watchdog;
 	ifp->if_init = ex_init;
-	ifp->if_snd.ifq_maxlen = IFQ_MAXLEN;
+	IFQ_SET_MAXLEN(&ifp->if_snd, IFQ_MAXLEN);
+	IFQ_SET_READY(&ifp->if_snd);
 
 	ifmedia_init(&sc->ifmedia, 0, ex_ifmedia_upd, ex_ifmedia_sts);
 
@@ -381,8 +382,10 @@
 	 * Main loop: send outgoing packets to network card until there are no
 	 * more packets left, or the card cannot accept any more yet.
 	 */
-	while (((opkt = ifp->if_snd.ifq_head) != NULL) &&
-	       !(ifp->if_flags & IFF_OACTIVE)) {
+	while (!(ifp->if_flags & IFF_OACTIVE)) {
+		IFQ_POLL(&ifp->if_snd, opkt);
+		if (opkt == NULL)
+			break;
 
 		/*
 		 * Ensure there is enough free transmit buffer space for
@@ -415,7 +418,7 @@
 		DODEBUG(Sent_Pkts, printf("i=%d, avail=%d\n", i, avail););
 
 		if (avail >= len + XMT_HEADER_LEN) {
-			IF_DEQUEUE(&ifp->if_snd, opkt);
+			IFQ_DEQUEUE(&ifp->if_snd, opkt);
 
 #ifdef EX_PSA_INTR      
 			/*
@@ -605,7 +608,7 @@
 	 * be sent, attempt to send more packets to the network card.
 	 */
 
-	if (send_pkts && (ifp->if_snd.ifq_head != NULL)) {
+	if (send_pkts && !IFQ_IS_EMPTY(&ifp->if_snd)) {
 		ex_start(ifp);
 	}
 
diff -urN ../sys/dev/fxp/if_fxp.c ./dev/fxp/if_fxp.c
--- ../sys/dev/fxp/if_fxp.c	Fri Aug 31 11:17:02 2001
+++ ./dev/fxp/if_fxp.c	Tue Oct  2 22:16:13 2001
@@ -614,6 +614,8 @@
 	ifp->if_ioctl = fxp_ioctl;
 	ifp->if_start = fxp_start;
 	ifp->if_watchdog = fxp_watchdog;
+	IFQ_SET_READY(&ifp->if_snd);
+	IFQ_SET_READY(&ifp->if_snd);
 
 	/*
 	 * Attach the interface.
@@ -631,7 +633,7 @@
 	 * Let the system queue as many packets as we have available
 	 * TX descriptors.
 	 */
-	ifp->if_snd.ifq_maxlen = FXP_NTXCB - 1;
+	IFQ_SET_MAXLEN(&ifp->if_snd, FXP_NTXCB - 1);
 
 	splx(s);
 	return (0);
@@ -1000,14 +1002,16 @@
 	 * NOTE: One TxCB is reserved to guarantee that fxp_mc_setup() can add
 	 *       a NOP command when needed.
 	 */
-	while (ifp->if_snd.ifq_head != NULL && sc->tx_queued < FXP_NTXCB - 1) {
+	while (!IFQ_IS_EMPTY(&ifp->if_snd) && sc->tx_queued < FXP_NTXCB - 1) {
 		struct mbuf *m, *mb_head;
 		int segment;
 
 		/*
 		 * Grab a packet to transmit.
 		 */
-		IF_DEQUEUE(&ifp->if_snd, mb_head);
+		IFQ_DEQUEUE(&ifp->if_snd, mb_head);
+		if (mb_head == NULL)
+			break;
 
 		/*
 		 * Get pointer to next available tx desc.
@@ -1118,6 +1122,11 @@
 	 * going again if suspended.
 	 */
 	if (txp != NULL) {
+#ifdef ALTQ
+		/* if tb regulator is used, we need tx complete interrupt */
+		if (TBR_IS_ENABLED(&ifp->if_snd))
+			txp->cb_command |= FXP_CB_COMMAND_I;
+#endif
 		fxp_scb_wait(sc);
 		fxp_scb_cmd(sc, FXP_SCB_COMMAND_CU_RESUME);
 	}
@@ -1186,7 +1195,7 @@
 			/*
 			 * Try to start more packets transmitting.
 			 */
-			if (ifp->if_snd.ifq_head != NULL)
+			if (!IFQ_IS_EMPTY(&ifp->if_snd))
 				fxp_start(ifp);
 		}
 		/*
diff -urN ../sys/dev/vx/if_vx.c ./dev/vx/if_vx.c
--- ../sys/dev/vx/if_vx.c	Mon Jul 30 07:48:37 2001
+++ ./dev/vx/if_vx.c	Tue Oct  2 22:06:19 2001
@@ -201,7 +201,7 @@
     ifp->if_unit = sc->unit;
     ifp->if_name = "vx";
     ifp->if_mtu = ETHERMTU;
-    ifp->if_snd.ifq_maxlen = IFQ_MAXLEN;
+    IFQ_SET_MAXLEN(&ifp->if_snd, IFQ_MAXLEN);
     ifp->if_flags = IFF_BROADCAST | IFF_SIMPLEX | IFF_MULTICAST;
     ifp->if_output = ether_output;
     ifp->if_start = vxstart;
@@ -209,6 +209,7 @@
     ifp->if_init = vxinit;
     ifp->if_watchdog = vxwatchdog;
     ifp->if_softc = sc;
+    IFQ_SET_READY(&ifp->if_snd);
 
     ether_ifattach(ifp, ETHER_BPF_SUPPORTED);
 
@@ -445,7 +446,7 @@
 
 startagain:
     /* Sneak a peek at the next packet */
-    m0 = ifp->if_snd.ifq_head;
+    IFQ_POLL(&ifp->if_snd, m0);
     if (m0 == 0) {
 	return;
     }
@@ -464,7 +465,7 @@
     if (len + pad > ETHER_MAX_LEN) {
 	/* packet is obviously too large: toss it */
 	++ifp->if_oerrors;
-	IF_DEQUEUE(&ifp->if_snd, m0);
+	IFQ_DEQUEUE(&ifp->if_snd, m0);
 	m_freem(m0);
 	goto readcheck;
     }
@@ -479,7 +480,7 @@
 	}
     }
     outw(BASE + VX_COMMAND, SET_TX_AVAIL_THRESH | (8188 >> 2));
-    IF_DEQUEUE(&ifp->if_snd, m0);
+    IFQ_DEQUEUE(&ifp->if_snd, m0);
     if (m0 == 0) {		/* not really needed */
 	return;
     }
diff -urN ../sys/i386/conf/ALTQ ./i386/conf/ALTQ
--- ../sys/i386/conf/ALTQ	Thu Jan  1 09:00:00 1970
+++ ./i386/conf/ALTQ	Tue Oct  2 22:20:13 2001
@@ -0,0 +1,277 @@
+#
+# GENERIC -- Generic kernel configuration file for FreeBSD/i386
+#
+# For more information on this file, please read the handbook section on
+# Kernel Configuration Files:
+#
+#    http://www.FreeBSD.org/handbook/kernelconfig-config.html
+#
+# The handbook is also available locally in /usr/share/doc/handbook
+# if you've installed the doc distribution, otherwise always see the
+# FreeBSD World Wide Web server (http://www.FreeBSD.org/) for the
+# latest information.
+#
+# An exhaustive list of options and more detailed explanations of the
+# device lines is also present in the ./LINT configuration file. If you are
+# in doubt as to the purpose or necessity of a line, check first in LINT.
+#
+# $FreeBSD: src/sys/i386/conf/GENERIC,v 1.246.2.34 2001/08/12 13:13:46 joerg Exp $
+
+machine		i386
+cpu		I386_CPU
+cpu		I486_CPU
+cpu		I586_CPU
+cpu		I686_CPU
+ident		ALTQ
+maxusers	32
+
+#makeoptions	DEBUG=-g		#Build kernel with gdb(1) debug symbols
+
+options 	MATH_EMULATE		#Support for x87 emulation
+options 	INET			#InterNETworking
+options 	INET6			#IPv6 communications protocols
+options 	FFS			#Berkeley Fast Filesystem
+options 	FFS_ROOT		#FFS usable as root device [keep this!]
+options 	SOFTUPDATES		#Enable FFS soft updates support
+options 	MFS			#Memory Filesystem
+options 	MD_ROOT			#MD is a potential root device
+options 	NFS			#Network Filesystem
+options 	NFS_ROOT		#NFS usable as root device, NFS required
+options 	MSDOSFS			#MSDOS Filesystem
+options 	CD9660			#ISO 9660 Filesystem
+options 	CD9660_ROOT		#CD-ROM usable as root, CD9660 required
+options 	PROCFS			#Process filesystem
+options 	COMPAT_43		#Compatible with BSD 4.3 [KEEP THIS!]
+options 	SCSI_DELAY=15000	#Delay (in ms) before probing SCSI
+options 	UCONSOLE		#Allow users to grab the console
+options 	USERCONFIG		#boot -c editor
+options 	VISUAL_USERCONFIG	#visual boot -c editor
+options 	KTRACE			#ktrace(1) support
+options 	SYSVSHM			#SYSV-style shared memory
+options 	SYSVMSG			#SYSV-style message queues
+options 	SYSVSEM			#SYSV-style semaphores
+options 	P1003_1B		#Posix P1003_1B real-time extensions
+options 	_KPOSIX_PRIORITY_SCHEDULING
+options		ICMP_BANDLIM		#Rate limit bad replies
+options 	KBD_INSTALL_CDEV	# install a CDEV entry in /dev
+
+# To make an SMP kernel, the next two are needed
+#options 	SMP			# Symmetric MultiProcessor Kernel
+#options 	APIC_IO			# Symmetric (APIC) I/O
+
+device		isa
+device		eisa
+device		pci
+
+# Floppy drives
+device		fdc0	at isa? port IO_FD1 irq 6 drq 2
+device		fd0	at fdc0 drive 0
+device		fd1	at fdc0 drive 1
+#
+# If you have a Toshiba Libretto with its Y-E Data PCMCIA floppy,
+# don't use the above line for fdc0 but the following one:
+#device		fdc0
+
+# ATA and ATAPI devices
+device		ata0	at isa? port IO_WD1 irq 14
+device		ata1	at isa? port IO_WD2 irq 15
+device		ata
+device		atadisk			# ATA disk drives
+device		atapicd			# ATAPI CDROM drives
+device		atapifd			# ATAPI floppy drives
+device		atapist			# ATAPI tape drives
+options 	ATA_STATIC_ID		#Static device numbering
+
+# SCSI Controllers
+device		ahb		# EISA AHA1742 family
+device		ahc		# AHA2940 and onboard AIC7xxx devices
+device		amd		# AMD 53C974 (Tekram DC-390(T))
+device		isp		# Qlogic family
+device		ncr		# NCR/Symbios Logic
+device		sym		# NCR/Symbios Logic (newer chipsets)
+options		SYM_SETUP_LP_PROBE_MAP=0x40
+				# Allow ncr to attach legacy NCR devices when 
+				# both sym and ncr are configured
+
+device		adv0	at isa?
+device		adw
+device		bt0	at isa?
+device		aha0	at isa?
+device		aic0	at isa?
+
+device		ncv		# NCR 53C500
+device		nsp		# Workbit Ninja SCSI-3
+device		stg		# TMC 18C30/18C50
+
+# SCSI peripherals
+device		scbus		# SCSI bus (required)
+device		da		# Direct Access (disks)
+device		sa		# Sequential Access (tape etc)
+device		cd		# CD
+device		pass		# Passthrough device (direct SCSI access)
+
+# RAID controllers interfaced to the SCSI subsystem
+device		asr		# DPT SmartRAID V, VI and Adaptec SCSI RAID
+device		dpt		# DPT Smartcache - See LINT for options!
+device		mly		# Mylex AcceleRAID/eXtremeRAID
+
+# RAID controllers
+device		aac		# Adaptec FSA RAID, Dell PERC2/PERC3
+device		ida		# Compaq Smart RAID
+device		amr		# AMI MegaRAID
+device		mlx		# Mylex DAC960 family
+device		twe		# 3ware Escalade
+
+# atkbdc0 controls both the keyboard and the PS/2 mouse
+device		atkbdc0	at isa? port IO_KBD
+device		atkbd0	at atkbdc? irq 1 flags 0x1
+device		psm0	at atkbdc? irq 12
+
+device		vga0	at isa?
+
+# splash screen/screen saver
+pseudo-device	splash
+
+# syscons is the default console driver, resembling an SCO console
+device		sc0	at isa? flags 0x100
+
+# Enable this and PCVT_FREEBSD for pcvt vt220 compatible console driver
+#device		vt0	at isa?
+#options 	XSERVER			# support for X server on a vt console
+#options 	FAT_CURSOR		# start with block cursor
+# If you have a ThinkPAD, uncomment this along with the rest of the PCVT lines
+#options 	PCVT_SCANSET=2		# IBM keyboards are non-std
+
+# Floating point support - do not disable.
+device		npx0	at nexus? port IO_NPX irq 13
+
+# Power management support (see LINT for more options)
+device		apm0    at nexus? disable flags 0x20 # Advanced Power Management
+
+# PCCARD (PCMCIA) support
+device		card
+device		pcic0	at isa? irq 0 port 0x3e0 iomem 0xd0000
+device		pcic1	at isa? irq 0 port 0x3e2 iomem 0xd4000 disable
+
+# Serial (COM) ports
+device		sio0	at isa? port IO_COM1 flags 0x10 irq 4
+device		sio1	at isa? port IO_COM2 irq 3
+device		sio2	at isa? disable port IO_COM3 irq 5
+device		sio3	at isa? disable port IO_COM4 irq 9
+
+# Parallel port
+device		ppc0	at isa? irq 7
+device		ppbus		# Parallel port bus (required)
+device		lpt		# Printer
+device		plip		# TCP/IP over parallel
+device		ppi		# Parallel port interface device
+#device		vpo		# Requires scbus and da
+
+
+# PCI Ethernet NICs.
+device		de		# DEC/Intel DC21x4x (``Tulip'')
+device		txp		# 3Com 3cR990 (``Typhoon'')
+device		vx		# 3Com 3c590, 3c595 (``Vortex'')
+
+# PCI Ethernet NICs that use the common MII bus controller code.
+# NOTE: Be sure to keep the 'device miibus' line in order to use these NICs!
+device		miibus		# MII bus support
+device		dc		# DEC/Intel 21143 and various workalikes
+device		fxp		# Intel EtherExpress PRO/100B (82557, 82558)
+device		pcn		# AMD Am79C97x PCI 10/100 NICs
+device		rl		# RealTek 8129/8139
+device		sf		# Adaptec AIC-6915 (``Starfire'')
+device		sis		# Silicon Integrated Systems SiS 900/SiS 7016
+device		ste		# Sundance ST201 (D-Link DFE-550TX)
+device		tl		# Texas Instruments ThunderLAN
+device		tx		# SMC EtherPower II (83c170 ``EPIC'')
+device		vr		# VIA Rhine, Rhine II
+device		wb		# Winbond W89C840F
+device		wx		# Intel Gigabit Ethernet Card (``Wiseman'')
+device		xl		# 3Com 3c90x (``Boomerang'', ``Cyclone'')
+
+# ISA Ethernet NICs.
+# 'device ed' requires 'device miibus'
+device		ed0	at isa? port 0x280 irq 10 iomem 0xd8000
+device		ex
+device		ep
+device		fe0	at isa? port 0x300
+# Xircom Ethernet
+device		xe
+# PRISM I IEEE 802.11b wireless NIC.
+device		awi
+# WaveLAN/IEEE 802.11 wireless NICs. Note: the WaveLAN/IEEE really
+# exists only as a PCMCIA device, so there is no ISA attachment needed
+# and resources will always be dynamically assigned by the pccard code.
+device		wi
+# Aironet 4500/4800 802.11 wireless NICs. Note: the declaration below will
+# work for PCMCIA and PCI cards, as well as ISA cards set to ISA PnP
+# mode (the factory default). If you set the switches on your ISA
+# card for a manually chosen I/O address and IRQ, you must specify
+# those parameters here.
+device		an
+# The probe order of these is presently determined by i386/isa/isa_compat.c.
+device		ie0	at isa? port 0x300 irq 10 iomem 0xd0000
+#device		le0	at isa? port 0x300 irq 5 iomem 0xd0000
+device		lnc0	at isa? port 0x280 irq 10 drq 0
+device		cs0	at isa? port 0x300
+device		sn0	at isa? port 0x300 irq 10
+
+# Pseudo devices - the number indicates how many units to allocate.
+pseudo-device	loop		# Network loopback
+pseudo-device	ether		# Ethernet support
+pseudo-device	sl	1	# Kernel SLIP
+pseudo-device	ppp	1	# Kernel PPP
+pseudo-device	tun		# Packet tunnel.
+pseudo-device	pty		# Pseudo-ttys (telnet etc)
+pseudo-device	md		# Memory "disks"
+pseudo-device	gif		# IPv6 and IPv4 tunneling
+pseudo-device	faith	1	# IPv6-to-IPv4 relaying (translation)
+
+# The `bpf' pseudo-device enables the Berkeley Packet Filter.
+# Be aware of the administrative consequences of enabling this!
+pseudo-device	bpf		#Berkeley packet filter
+
+# USB support
+device		uhci		# UHCI PCI->USB interface
+device		ohci		# OHCI PCI->USB interface
+device		usb		# USB Bus (required)
+device		ugen		# Generic
+device		uhid		# "Human Interface Devices"
+device		ukbd		# Keyboard
+device		ulpt		# Printer
+device		umass		# Disks/Mass storage - Requires scbus and da
+device		ums		# Mouse
+device		uscanner	# Scanners
+# USB Ethernet, requires mii
+device		aue		# ADMtek USB ethernet
+device		cue		# CATC USB ethernet
+device		kue		# Kawasaki LSI USB ethernet
+
+# ALTQ options
+options 	ALTQ		#alternate queueing
+#options 	ALTQ_CBQ	#class based queueing
+#options 	ALTQ_WFQ	#weighted fair queueing
+#options 	ALTQ_FIFOQ	#fifo queueing
+#options 	ALTQ_RED	#random early detection
+#options 	ALTQ_FLOWVALVE	#flowvalve for RED (needs RED)
+#options 	ALTQ_RIO	#triple	 red for diffserv (needs RED)
+#options 	ALTQ_LOCALQ	#local use
+#options 	ALTQ_HFSC	#hierarchical fair service curve
+#options 	ALTQ_ECN	#ecn extention to tcp (needs RED)
+#options 	ALTQ_IPSEC	#check ipsec in IPv4
+#options 	ALTQ_CDNR	#diffserv traffic conditioner
+#options 	ALTQ_BLUE	#blue by wu-chang feng
+#options 	ALTQ_PRIQ	#priority queue
+#options 	ALTQ_NOPCC	#don't use processor cycle counter
+#options 	ALTQ_DEBUG	#for debugging
+# you might want to set kernel timer to 1kHz if you use CBQ,
+# especially with 100baseT
+#options 	HZ=1000
+
+# options added for ALTQ
+options		NMBCLUSTERS=2048
+options		MROUTING		# Multicast routing
+pseudo-device	atm
+device		en
+#options	NATM			#native mode atm
diff -urN ../sys/i386/conf/LINT ./i386/conf/LINT
--- ../sys/i386/conf/LINT	Thu Aug 30 21:29:56 2001
+++ ./i386/conf/LINT	Tue Oct  2 22:06:19 2001
@@ -2526,3 +2526,21 @@
 options 	VM_KMEM_SIZE_MAX
 options 	VM_KMEM_SIZE_SCALE
 options		XBONEHACK
+
+# ALTQ options
+options 	ALTQ		#alternate queueing
+options 	ALTQ_CBQ	#class based queueing
+options 	ALTQ_WFQ	#weighted fair queueing
+options 	ALTQ_FIFOQ	#fifo queueing
+options 	ALTQ_RED	#random early detection
+options 	ALTQ_FLOWVALVE	#flowvalve for RED (needs RED)
+options 	ALTQ_RIO	#triple	 red for diffserv (needs RED)
+options 	ALTQ_LOCALQ	#local use
+options 	ALTQ_HFSC	#hierarchical fair service curve
+options 	ALTQ_ECN	#ecn extention to tcp (needs RED)
+options 	ALTQ_IPSEC	#check ipsec in IPv4
+options 	ALTQ_CDNR	#diffserv traffic conditioner
+options 	ALTQ_BLUE	#blue by wu-chang feng
+options 	ALTQ_PRIQ	#priority queue
+options 	ALTQ_NOPCC	#don't use processor cycle counter
+options 	ALTQ_DEBUG	#for debugging
diff -urN ../sys/i386/isa/if_ar.c ./i386/isa/if_ar.c
--- ../sys/i386/isa/if_ar.c	Fri Jan 21 10:39:39 2000
+++ ./i386/isa/if_ar.c	Tue Oct  2 22:06:19 2001
@@ -472,6 +472,7 @@
 		ifp->if_ioctl = arioctl;
 		ifp->if_start = arstart;
 		ifp->if_watchdog = arwatchdog;
+		IFQ_SET_READY(&ifp->if_snd);
 
 		sc->ifsppp.pp_flags = PP_KEEPALIVE;
 
diff -urN ../sys/i386/isa/if_cx.c ./i386/isa/if_cx.c
--- ../sys/i386/isa/if_cx.c	Thu Nov 18 17:36:42 1999
+++ ./i386/isa/if_cx.c	Tue Oct  2 22:06:19 2001
@@ -273,6 +273,7 @@
 			c->ifp->if_ioctl = cxsioctl;
 			c->ifp->if_start = (start_func_t) cxstart;
 			c->ifp->if_watchdog = (watchdog_func_t) cxwatchdog;
+			IFQ_SET_READY(&c->ifp->if_snd);
 			/* Init routine is never called by upper level? */
 			sppp_attach (c->ifp);
 			if_attach (c->ifp);
diff -urN ../sys/i386/isa/if_lnc.c ./i386/isa/if_lnc.c
--- ../sys/i386/isa/if_lnc.c	Tue Jan  9 00:37:59 2001
+++ ./i386/isa/if_lnc.c	Tue Oct  2 22:06:19 2001
@@ -356,6 +356,7 @@
 
 	head = desc->buff.mbuf;
 	head->m_flags |= M_PKTHDR;
+	bzero(&head->m_pkthdr, sizeof(head->m_pkthdr));
 
 	m = head;
 	do {
@@ -1240,7 +1241,8 @@
 	sc->arpcom.ac_if.if_type = IFT_ETHER;
 	sc->arpcom.ac_if.if_addrlen = ETHER_ADDR_LEN;
 	sc->arpcom.ac_if.if_hdrlen = ETHER_HDR_LEN;
-	sc->arpcom.ac_if.if_snd.ifq_maxlen = IFQ_MAXLEN;
+	IFQ_SET_MAXLEN(&sc->arpcom.ac_if.if_snd, IFQ_MAXLEN);
+	IFQ_SET_READY(&sc->arpcom.ac_if.if_snd);
 
 	ether_ifattach(&sc->arpcom.ac_if, ETHER_BPF_SUPPORTED);
 
@@ -1649,7 +1651,7 @@
 
 	do {
 
-		IF_DEQUEUE(&sc->arpcom.ac_if.if_snd, head);
+		IFQ_DEQUEUE(&sc->arpcom.ac_if.if_snd, head);
 		if (!head)
 			return;
 
diff -urN ../sys/i386/isa/if_sr.c ./i386/isa/if_sr.c
--- ../sys/i386/isa/if_sr.c	Thu Mar  1 04:08:56 2001
+++ ./i386/isa/if_sr.c	Tue Oct  2 22:06:19 2001
@@ -913,6 +913,7 @@
 		ifp->if_ioctl = srioctl;
 		ifp->if_start = srstart;
 		ifp->if_watchdog = srwatchdog;
+		IFQ_SET_READY(&ifp->if_snd);
 
 		sc->ifsppp.pp_flags = PP_KEEPALIVE;
 		sppp_attach((struct ifnet *)&sc->ifsppp);
diff -urN ../sys/i386/isa/if_wi.c ./i386/isa/if_wi.c
--- ../sys/i386/isa/if_wi.c	Tue Aug 28 15:21:14 2001
+++ ./i386/isa/if_wi.c	Tue Oct  2 22:08:51 2001
@@ -483,7 +483,8 @@
 	ifp->if_watchdog = wi_watchdog;
 	ifp->if_init = wi_init;
 	ifp->if_baudrate = 10000000;
-	ifp->if_snd.ifq_maxlen = IFQ_MAXLEN;
+	IFQ_SET_MAXLEN(&ifp->if_snd, IFQ_MAXLEN);
+	IFQ_SET_READY(&ifp->if_snd);
 
 	bzero(sc->wi_node_name, sizeof(sc->wi_node_name));
 	bcopy(WI_DEFAULT_NODENAME, sc->wi_node_name,
@@ -815,7 +816,7 @@
 	/* Re-enable interrupts. */
 	CSR_WRITE_2(sc, WI_INT_EN, WI_INTRS);
 
-	if (ifp->if_snd.ifq_head != NULL) {
+	if (!IFQ_IS_EMPTY(&ifp->if_snd)) {
 		wi_start(ifp);
 	}
 
@@ -1782,7 +1783,7 @@
 		return;
 	}
 
-	IF_DEQUEUE(&ifp->if_snd, m0);
+	IFQ_DEQUEUE(&ifp->if_snd, m0);
 	if (m0 == NULL) {
 		return;
 	}
diff -urN ../sys/i386/isa/if_wl.c ./i386/isa/if_wl.c
--- ../sys/i386/isa/if_wl.c	Tue Jul 18 06:24:32 2000
+++ ./i386/isa/if_wl.c	Tue Oct  2 22:06:19 2001
@@ -505,6 +505,7 @@
        ifp->if_done
        ifp->if_reset
        */
+    IFQ_SET_READY(&ifp->if_snd);
     ether_ifattach(ifp, ETHER_BPF_SUPPORTED);
 
     bcopy(&sc->wl_addr[0], sc->wl_ac.ac_enaddr, WAVELAN_ADDR_SIZE);
@@ -886,7 +887,7 @@
 
     /* get ourselves some data */
     ifp = &(sc->wl_if);
-    IF_DEQUEUE(&ifp->if_snd, m);
+    IFQ_DEQUEUE(&ifp->if_snd, m);
     if (m != (struct mbuf *)0) {
 	/* let BPF see it before we commit it */
 	if (ifp->if_bpf) {
diff -urN ../sys/modules/Makefile ./modules/Makefile
--- ../sys/modules/Makefile	Sat Aug 11 09:54:14 2001
+++ ./modules/Makefile	Tue Oct  2 22:06:20 2001
@@ -100,6 +100,8 @@
 	wi
 .endif
 
+SUBDIR+=altq
+
 .if ${MACHINE} == "pc98"
 SUBDIR+=snc
 .endif
diff -urN ../sys/modules/altq/Makefile ./modules/altq/Makefile
--- ../sys/modules/altq/Makefile	Thu Jan  1 09:00:00 1970
+++ ./modules/altq/Makefile	Tue Oct  2 22:06:20 2001
@@ -0,0 +1,4 @@
+
+SUBDIR=	altq_blue altq_cbq altq_cdnr altq_fifoq altq_hfsc altq_localq altq_priq altq_red altq_rio altq_wfq
+
+.include <bsd.subdir.mk>
diff -urN ../sys/modules/altq/Makefile.inc ./modules/altq/Makefile.inc
--- ../sys/modules/altq/Makefile.inc	Thu Jan  1 09:00:00 1970
+++ ./modules/altq/Makefile.inc	Tue Oct  2 22:06:20 2001
@@ -0,0 +1,3 @@
+# $Id: Makefile.inc,v 1.1 2000/04/17 11:32:21 kjc Exp $
+
+KLDMOD=	true
diff -urN ../sys/modules/altq/altq_blue/Makefile ./modules/altq/altq_blue/Makefile
--- ../sys/modules/altq/altq_blue/Makefile	Thu Jan  1 09:00:00 1970
+++ ./modules/altq/altq_blue/Makefile	Tue Oct  2 22:06:20 2001
@@ -0,0 +1,28 @@
+
+.PATH:	${.CURDIR}/../../../altq
+KMOD=	altq_blue
+SRCS=	altq_blue.c opt_altq.h opt_inet.h opt_inet6.h
+
+CFLAGS+= -DALTQ
+CLEANFILES+= opt_altq.h opt_inet.h opt_inet6.h
+
+ALTQMOD_INET?=	1
+ALTQMOD_INET6?=	1
+
+opt_altq.h:
+	echo "#define ALTQ_BLUE 1" > opt_altq.h
+
+opt_inet.h:
+	touch opt_inet.h
+.if ${ALTQMOD_INET} > 0
+	echo "#define INET 1" > opt_inet.h
+.endif
+
+opt_inet6.h:
+	touch opt_inet6.h
+.if ${ALTQMOD_INET6} > 0
+	echo "#define INET6 1" > opt_inet6.h
+.endif
+
+.include <bsd.kmod.mk>
+
diff -urN ../sys/modules/altq/altq_cbq/Makefile ./modules/altq/altq_cbq/Makefile
--- ../sys/modules/altq/altq_cbq/Makefile	Thu Jan  1 09:00:00 1970
+++ ./modules/altq/altq_cbq/Makefile	Tue Oct  2 22:06:20 2001
@@ -0,0 +1,41 @@
+
+.PATH:	${.CURDIR}/../../../altq
+KMOD=	altq_cbq
+SRCS=	altq_cbq.c altq_rmclass.c opt_altq.h opt_inet.h opt_inet6.h
+KMODDEPS=	altq_red altq_rio
+
+CFLAGS+= -DALTQ
+CLEANFILES+= opt_altq.h opt_inet.h opt_inet6.h
+
+ALTQMOD_ALTQ_RED?=	1
+ALTQMOD_ALTQ_RIO?=	1
+ALTQMOD_ALTQ_FLOWVALVE?=	1
+ALTQMOD_INET?=	1
+ALTQMOD_INET6?=	1
+
+opt_altq.h:
+	echo "#define ALTQ_CBQ 1" > opt_altq.h
+.if ${ALTQMOD_ALTQ_RED} > 0
+	echo "#define ALTQ_RED 1" >> opt_altq.h
+.endif
+.if ${ALTQMOD_ALTQ_RIO} > 0
+	echo "#define ALTQ_RIO 1" >> opt_altq.h
+.endif
+.if ${ALTQMOD_ALTQ_FLOWVALVE} > 0
+	echo "#define ALTQ_FLOWVALVE 1" >> opt_altq.h
+.endif
+
+opt_inet.h:
+	touch opt_inet.h
+.if ${ALTQMOD_INET} > 0
+	echo "#define INET 1" > opt_inet.h
+.endif
+
+opt_inet6.h:
+	touch opt_inet6.h
+.if ${ALTQMOD_INET6} > 0
+	echo "#define INET6 1" > opt_inet6.h
+.endif
+
+.include <bsd.kmod.mk>
+
diff -urN ../sys/modules/altq/altq_cdnr/Makefile ./modules/altq/altq_cdnr/Makefile
--- ../sys/modules/altq/altq_cdnr/Makefile	Thu Jan  1 09:00:00 1970
+++ ./modules/altq/altq_cdnr/Makefile	Tue Oct  2 22:06:20 2001
@@ -0,0 +1,28 @@
+
+.PATH:	${.CURDIR}/../../../altq
+KMOD=	altq_cdnr
+SRCS=	altq_cdnr.c opt_altq.h opt_inet.h opt_inet6.h
+
+CFLAGS+= -DALTQ
+CLEANFILES+= opt_altq.h opt_inet.h opt_inet6.h
+
+ALTQMOD_INET?=	1
+ALTQMOD_INET6?=	1
+
+opt_altq.h:
+	echo "#define ALTQ_CDNR 1" > opt_altq.h
+
+opt_inet.h:
+	touch opt_inet.h
+.if ${ALTQMOD_INET} > 0
+	echo "#define INET 1" > opt_inet.h
+.endif
+
+opt_inet6.h:
+	touch opt_inet6.h
+.if ${ALTQMOD_INET6} > 0
+	echo "#define INET6 1" > opt_inet6.h
+.endif
+
+.include <bsd.kmod.mk>
+
diff -urN ../sys/modules/altq/altq_fifoq/Makefile ./modules/altq/altq_fifoq/Makefile
--- ../sys/modules/altq/altq_fifoq/Makefile	Thu Jan  1 09:00:00 1970
+++ ./modules/altq/altq_fifoq/Makefile	Tue Oct  2 22:06:20 2001
@@ -0,0 +1,13 @@
+
+.PATH:	${.CURDIR}/../../../altq
+KMOD=	altq_fifoq
+SRCS=	altq_fifoq.c opt_altq.h
+
+CFLAGS+= -DALTQ
+CLEANFILES+= opt_altq.h
+
+opt_altq.h:
+	echo "#define ALTQ_FIFOQ 1" > opt_altq.h
+
+.include <bsd.kmod.mk>
+
diff -urN ../sys/modules/altq/altq_hfsc/Makefile ./modules/altq/altq_hfsc/Makefile
--- ../sys/modules/altq/altq_hfsc/Makefile	Thu Jan  1 09:00:00 1970
+++ ./modules/altq/altq_hfsc/Makefile	Tue Oct  2 22:06:20 2001
@@ -0,0 +1,40 @@
+
+.PATH:	${.CURDIR}/../../../altq
+KMOD=	altq_hfsc
+SRCS=	altq_hfsc.c opt_altq.h opt_inet.h opt_inet6.h
+KMODDEPS=	altq_red altq_rio
+
+CFLAGS+= -DALTQ
+CLEANFILES+= opt_altq.h opt_inet.h opt_inet6.h
+
+ALTQMOD_ALTQ_RED?=	1
+ALTQMOD_ALTQ_RIO?=	1
+ALTQMOD_ALTQ_FLOWVALVE?=	1
+ALTQMOD_INET?=	1
+ALTQMOD_INET6?=	1
+
+opt_altq.h:
+	echo "#define ALTQ_HFSC 1" > opt_altq.h
+.if ${ALTQMOD_ALTQ_RED} > 0
+	echo "#define ALTQ_RED 1" >> opt_altq.h
+.endif
+.if ${ALTQMOD_ALTQ_RIO} > 0
+	echo "#define ALTQ_RIO 1" >> opt_altq.h
+.endif
+.if ${ALTQMOD_ALTQ_FLOWVALVE} > 0
+	echo "#define ALTQ_FLOWVALVE 1" >> opt_altq.h
+.endif
+
+opt_inet.h:
+	touch opt_inet.h
+.if ${ALTQMOD_INET} > 0
+	echo "#define INET 1" > opt_inet.h
+.endif
+
+opt_inet6.h:
+	touch opt_inet6.h
+.if ${ALTQMOD_INET6} > 0
+	echo "#define INET6 1" > opt_inet6.h
+.endif
+
+.include <bsd.kmod.mk>
diff -urN ../sys/modules/altq/altq_localq/Makefile ./modules/altq/altq_localq/Makefile
--- ../sys/modules/altq/altq_localq/Makefile	Thu Jan  1 09:00:00 1970
+++ ./modules/altq/altq_localq/Makefile	Tue Oct  2 22:06:20 2001
@@ -0,0 +1,12 @@
+
+.PATH:	${.CURDIR}/../../../altq
+KMOD=	altq_localq
+SRCS=	altq_localq.c opt_altq.h
+
+CFLAGS+= -DALTQ
+CLEANFILES+= opt_altq.h
+
+opt_altq.h:
+	echo "#define ALTQ_LOCALQ 1" > opt_altq.h
+
+.include <bsd.kmod.mk>
diff -urN ../sys/modules/altq/altq_priq/Makefile ./modules/altq/altq_priq/Makefile
--- ../sys/modules/altq/altq_priq/Makefile	Thu Jan  1 09:00:00 1970
+++ ./modules/altq/altq_priq/Makefile	Tue Oct  2 22:06:20 2001
@@ -0,0 +1,40 @@
+
+.PATH:	${.CURDIR}/../../../altq
+KMOD=	altq_priq
+SRCS=	altq_priq.c opt_altq.h opt_inet.h opt_inet6.h
+KMODDEPS=	altq_red altq_rio
+
+CFLAGS+= -DALTQ
+CLEANFILES+= opt_altq.h opt_inet.h opt_inet6.h
+
+ALTQMOD_ALTQ_RED?=	1
+ALTQMOD_ALTQ_RIO?=	1
+ALTQMOD_ALTQ_FLOWVALVE?=	1
+ALTQMOD_INET?=	1
+ALTQMOD_INET6?=	1
+
+opt_altq.h:
+	echo "#define ALTQ_PRIQ 1" > opt_altq.h
+.if ${ALTQMOD_ALTQ_RED} > 0
+	echo "#define ALTQ_RED 1" >> opt_altq.h
+.endif
+.if ${ALTQMOD_ALTQ_RIO} > 0
+	echo "#define ALTQ_RIO 1" >> opt_altq.h
+.endif
+.if ${ALTQMOD_ALTQ_FLOWVALVE} > 0
+	echo "#define ALTQ_FLOWVALVE 1" >> opt_altq.h
+.endif
+
+opt_inet.h:
+	touch opt_inet.h
+.if ${ALTQMOD_INET} > 0
+	echo "#define INET 1" > opt_inet.h
+.endif
+
+opt_inet6.h:
+	touch opt_inet6.h
+.if ${ALTQMOD_INET6} > 0
+	echo "#define INET6 1" > opt_inet6.h
+.endif
+
+.include <bsd.kmod.mk>
diff -urN ../sys/modules/altq/altq_red/Makefile ./modules/altq/altq_red/Makefile
--- ../sys/modules/altq/altq_red/Makefile	Thu Jan  1 09:00:00 1970
+++ ./modules/altq/altq_red/Makefile	Tue Oct  2 22:06:20 2001
@@ -0,0 +1,32 @@
+
+.PATH:	${.CURDIR}/../../../altq
+KMOD=	altq_red
+SRCS=	altq_red.c opt_altq.h opt_inet.h opt_inet6.h
+
+CFLAGS+= -DALTQ
+CLEANFILES+= opt_altq.h opt_inet.h opt_inet6.h
+
+ALTQMOD_ALTQ_FLOWVALVE?=	1
+ALTQMOD_INET?=	1
+ALTQMOD_INET6?=	1
+
+opt_altq.h:
+	echo "#define ALTQ_RED 1" > opt_altq.h
+.if ${ALTQMOD_ALTQ_FLOWVALVE} > 0
+	echo "#define ALTQ_FLOWVALVE 1" >> opt_altq.h
+.endif
+
+opt_inet.h:
+	touch opt_inet.h
+.if ${ALTQMOD_INET} > 0
+	echo "#define INET 1" > opt_inet.h
+.endif
+
+opt_inet6.h:
+	touch opt_inet6.h
+.if ${ALTQMOD_INET6} > 0
+	echo "#define INET6 1" > opt_inet6.h
+.endif
+
+.include <bsd.kmod.mk>
+
diff -urN ../sys/modules/altq/altq_rio/Makefile ./modules/altq/altq_rio/Makefile
--- ../sys/modules/altq/altq_rio/Makefile	Thu Jan  1 09:00:00 1970
+++ ./modules/altq/altq_rio/Makefile	Tue Oct  2 22:06:21 2001
@@ -0,0 +1,28 @@
+
+.PATH:	${.CURDIR}/../../../altq
+KMOD=	altq_rio
+SRCS=	altq_rio.c opt_altq.h opt_inet.h opt_inet6.h
+
+CFLAGS+= -DALTQ
+CLEANFILES+= opt_altq.h opt_inet.h opt_inet6.h
+
+ALTQMOD_INET?=	1
+ALTQMOD_INET6?=	1
+
+opt_altq.h:
+	echo "#define ALTQ_RIO 1" > opt_altq.h
+
+opt_inet.h:
+	touch opt_inet.h
+.if ${ALTQMOD_INET} > 0
+	echo "#define INET 1" > opt_inet.h
+.endif
+
+opt_inet6.h:
+	touch opt_inet6.h
+.if ${ALTQMOD_INET6} > 0
+	echo "#define INET6 1" > opt_inet6.h
+.endif
+
+.include <bsd.kmod.mk>
+
diff -urN ../sys/modules/altq/altq_wfq/Makefile ./modules/altq/altq_wfq/Makefile
--- ../sys/modules/altq/altq_wfq/Makefile	Thu Jan  1 09:00:00 1970
+++ ./modules/altq/altq_wfq/Makefile	Tue Oct  2 22:06:21 2001
@@ -0,0 +1,26 @@
+
+.PATH:	${.CURDIR}/../../../altq
+KMOD=	altq_wfq
+SRCS=	altq_wfq.c opt_altq.h opt_inet.h opt_inet6.h
+
+CFLAGS+= -DALTQ
+CLEANFILES+= opt_altq.h opt_inet.h opt_inet6.h
+
+ALTQMOD_INET?=	1
+ALTQMOD_INET6?=	1
+
+opt_altq.h:
+	echo "#define ALTQ_WFQ 1" > opt_altq.h
+
+opt_inet.h:
+	touch opt_inet.h
+.if ${ALTQMOD_INET} > 0
+	echo "#define INET 1" > opt_inet.h
+.endif
+
+opt_inet6.h:
+	touch opt_inet6.h
+.if ${ALTQMOD_INET6} > 0
+	echo "#define INET6 1" > opt_inet6.h
+.endif
+.include <bsd.kmod.mk>
